#include <helloDlg.h>

int main(int argc, char* argv[]) {
  QApplication app(argc,argv);
  Ice::CommunicatorPtr ic;
  CallQueuePtr queue = new CallQueue();
  int status;
  try {
    ic = Ice::initialize(argc,argv);
    Ice::ObjectPrx base = ic->stringToProxy("SimplePrinter@HelloAdapter");
    helloDialogPrx hello = helloDialogPrx::checkedCast(base);
    queue->start();
    HelloDlg mw(queue, hello);
    mw.show();
    status = app.exec();
  }
  catch (const Ice::Exception& ex) {
    cerr << ex << endl;
    status = 1;
  } catch (const char* msg) {
    cerr << msg << endl;
    status = 1;
  }
  if (ic) {
    queue->destroy();
    queue->getThreadControl().join();
    ic->destroy();
  }
  return status;
}
