#include <Ice/Ice.h>
#include <helloDialog.h>

using namespace std;
using namespace Demo;

Ice::CommunicatorPtr ic;

class helloDialogI : public helloDialog {
public:
  virtual void sayHello(const Ice::Current&);
  virtual void shutdown(const Ice::Current&);
};

void
helloDialogI::
sayHello(const Ice::Current&)
{
     cout << "Hello!" << endl;
}

void
helloDialogI::
shutdown(const Ice::Current& c) {
  c.adapter->getCommunicator()->shutdown();
}

int
main(int argc, char* argv[])
{
     int status = 0;
     Ice::CommunicatorPtr ic;
     try {
         ic = Ice::initialize(argc, argv);
         Ice::ObjectAdapterPtr adapter
             = ic->createObjectAdapter(
                 "Hello");
         Ice::ObjectPtr object = new helloDialogI;
         adapter->add(object,
                      ic->stringToIdentity("SimplePrinter"));
         adapter->activate();
         ic->waitForShutdown();
     } catch (const Ice::Exception& e) {
      cerr << e << endl;
      status = 1;
  } catch (const char* msg) {
      cerr << msg << endl;
      status = 1;
  }
  if (ic) {
      try {
          ic->destroy();
      } catch (const Ice::Exception& e) {
          cerr << e << endl;
          status = 1;
      }
  }
  return status;
}
